clear all
clc;

realization = 20000;
%% Test case 1 for simulation
weather_case = 4; % run for 3 weather test cases
% generate data
P_d_min = 1; % minimum active demand
P_d_max = 3; % max active demand
Q_d_max = 0.7*P_d_max; % Q_demand = 0.2*P_demand;
PV_pene_level = 0.2; % penetration level of renewable units+

%% Set parameters
N = 250; % number of users/nodes 
% P_d = P_d_min + (P_d_max-P_d_min)*rand(N,1); % real power demand
% Q_d = Q_d_max*rand(N,1); % reactive demand
S_max = 2.2*ones(N,1); % nameplate capacity of DU units
% P_g_max = (0.75 + (1-0.75).*rand(N,1)).*S_max; % maximum real power generation capcity of renewable units from 0.75 -> max
lambda = 6.6; % real power price
kappa =  1.25*lambda; % reactive price

% Q_d = Q_d_max*rand(N,1); % reactive demand
load('Input\P_demand.mat','P_d');
load('Input\Q_demand.mat','Q_d');
%load('Input\Pg_max.mat','P_g_max'); % this data corresponding to weather case 1 , which is sunny p_g_mag from 0.75-1

%% this piece of code is used to generate array of users equipped with DG units
% for PV_pene_level = 0.1:0.1:0.8
%  user_PV =  randperm(N,floor(PV_pene_level*N));
%  file_name=sprintf('Input\\userPV_%d.mat',int8(PV_pene_level*100));
%  save(file_name,'user_PV');
% end

%load('userPV.mat','user_PV');

%% this piece of code to generate weather case
% for w_case = 1:weather_case
%     P_g_max = ( 0.25*(w_case-1) + 0.25.*rand(N,1) ).*S_max;
%     file_name=sprintf('Input\\Pg_max_%d.mat',w_case);
%     save(file_name,'P_g_max');
% end
%% define variable for active and reactive power generation
P_g_nocompen = zeros(N,1);
P_g = zeros(N,1);
Q_g = zeros(N,1);
% total demand of real and reactive power demand before compensation
P_d_total = sum(P_d);
Q_d_total = sum(Q_d);
% calculate Power factor for 0% of PV users
PF_orig = P_d_total/sqrt(P_d_total^2 + Q_d_total^2);

Pene_level = [10;20;30;40;50;60;70;80];
PowerFactor = zeros(length(Pene_level),weather_case);

Outdata = Pene_level; % array to store the output value of power factor

for j = 1:weather_case
    % for each weather case, load data of renewable capacity Pg_max
    file_input = sprintf('Input\\Pg_max_%d.mat',j);
    load(file_input,'P_g_max');
    for k=0.1:0.1:0.8 % for each penetration level
    % load file userPV.mat to determine which users are equipped with PV
    
    % for each penetration level, random select users with DG and run
    % number of realization times
%     file_name=sprintf('Input\\userPV_%d.mat',int8(k*100));
%     load(file_name,'user_PV');
    PF_temp = zeros(realization,1);
    for noofexp = 1:realization
        % random select users with DG
        
        user_PV = randperm(N,floor(k*N));
            % generate variable 
            P_g_nocompen = zeros(N,1);
            P_g = zeros(N,1);
            Q_g = zeros(N,1);
        %% optimal active and reactive power generation 
                for i=1:length(user_PV)
            % acive power generation without reactive power compensation
                    P_g_nocompen(user_PV(i)) = min(P_d(user_PV(i)),P_g_max(user_PV(i)));

            % real and reactive power generation with compensation
                    if (P_g_nocompen(user_PV(i))^2 + Q_d(user_PV(i))^2 <= S_max(user_PV(i))^2) % if the total demand less than generation capacity
                        P_g(user_PV(i)) = P_g_nocompen(user_PV(i));
                         Q_g(user_PV(i)) = Q_d(user_PV(i));
                    else        
                        P_g(user_PV(i)) = min(P_g_nocompen(user_PV(i)), lambda*S_max(user_PV(i))/sqrt(lambda^2 + kappa^2) ); % real power generation          
                        Q_g(user_PV(i)) = min( Q_d(user_PV(i)), kappa*S_max(user_PV(i))/sqrt(lambda^2 + kappa^2) ); % reactive power generation        
                    end

                end


        % determnine the total power dispath after compensation

                P_inj = sum(P_d - P_g);
                Q_inj = sum(Q_d - Q_g);

        % calculate power factor
                PF_new = P_inj/sqrt(P_inj^2 + Q_inj^2);
                PF_temp(noofexp) = PF_new;
        
    end
    PowerFactor(int8(k*10),j) = mean(PF_temp);
    end
    
%% write to excel file 

end
Outdata = [Pene_level PowerFactor];
xlswrite('Output\PF_vs_Penetration_monte.xlsx',Outdata);
